# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}

%define section     free
%define bname     wagon

Name:           maven-%{bname}
Version:        1.0
Release:        0.a5.1jpp
#Release:        0.20051102.1jpp
Epoch:          0
Summary:        Maven Wagon
License:        Apache Software License 2.0
Group:          Development/Java
Vendor:         JPackage Project
Distribution:   JPackage
URL:            http://maven.apache.org/wagon
Source0:        wagon-1.0-alpha-5-src.tar.gz
# svn export http://svn.apache.org/repos/asf/maven/wagon/tags/wagon-1.0-alpha-5/
Source1:        wagon-1.0-provider-api-build.xml
Source2:        wagon-1.0-provider-api-project.xml
Source3:        wagon-1.0-provider-test-build.xml
Source4:        wagon-1.0-provider-test-project.xml
Source5:        wagon-1.0-file-provider-build.xml
Source6:        wagon-1.0-file-provider-project.xml
Source7:        wagon-1.0-ftp-provider-build.xml
Source8:        wagon-1.0-ftp-provider-project.xml
Source9:        wagon-1.0-http-provider-build.xml
Source10:       wagon-1.0-http-provider-project.xml
Source11:       wagon-1.0-http-lightweight-provider-build.xml
Source12:       wagon-1.0-http-lightweight-provider-project.xml
Source13:       wagon-1.0-scm-provider-build.xml
Source14:       wagon-1.0-scm-provider-project.xml
Source15:       wagon-1.0-ssh-provider-build.xml
Source16:       wagon-1.0-ssh-provider-project.xml
Source17:       wagon-1.0-ssh-external-provider-build.xml
Source18:       wagon-1.0-ssh-external-provider-project.xml

Patch0:         wagon-1.0-provider-api-index.patch
Patch1:         wagon-1.0-FtpWagon.patch
Patch2:         wagon-1.0-ScmWagon.patch
Patch3:         wagon-1.0-TraditionalUIKeyboardInteractive.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:1.6
%if %{with_maven}
BuildRequires:  maven
%endif
BuildRequires:  classworlds
BuildRequires:  concurrent
BuildRequires:  excalibur-avalon-framework-api
BuildRequires:  excalibur-avalon-framework-impl
BuildRequires:  excalibur-cornerstone-connection-api
BuildRequires:  excalibur-cornerstone-connection-impl
BuildRequires:  excalibur-cornerstone-sockets-api
BuildRequires:  excalibur-cornerstone-sockets-impl
BuildRequires:  excalibur-cornerstone-threads-api
BuildRequires:  excalibur-cornerstone-threads-impl
BuildRequires:  excalibur-pool-api
BuildRequires:  excalibur-pool-impl
BuildRequires:  excalibur-thread-api
BuildRequires:  excalibur-thread-impl
BuildRequires:  jakarta-commons-net
BuildRequires:  jakarta-commons-collections
BuildRequires:  jakarta-commons-httpclient
BuildRequires:  jakarta-commons-logging
BuildRequires:  jetty4
BuildRequires:  jsch
BuildRequires:  maven-scm
BuildRequires:  oro
BuildRequires:  plexus-avalon-personality
BuildRequires:  plexus-container-default
BuildRequires:  plexus-ftpd
BuildRequires:  plexus-interactivity
BuildRequires:  plexus-jetty-httpd
BuildRequires:  plexus-utils
BuildRequires:  servletapi4


%description
Maven Wagon is a transport abstraction that is used in Maven's 
artifact and repository handling code. Currently wagon has the 
following providers:
* File
* HTTP
* FTP
* SSH/SCP
* WebDAV (in progress)

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%if %{with_maven}
%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
Documents for %{name}.
%endif

%prep
cat <<EOT


If you don''t want to build with maven, and use straight ant instead,
give rpmbuild option '--without maven'

EOT
%setup -q -n %{bname}-%{version}-alpha-5
cp %{SOURCE1} wagon-provider-api/build.xml
cp %{SOURCE2} wagon-provider-api/project.xml
cp %{SOURCE3} wagon-provider-test/build.xml
cp %{SOURCE4} wagon-provider-test/project.xml
cp %{SOURCE5} wagon-providers/wagon-file/build.xml
cp %{SOURCE6} wagon-providers/wagon-file/project.xml
cp %{SOURCE7} wagon-providers/wagon-ftp/build.xml
cp %{SOURCE8} wagon-providers/wagon-ftp/project.xml
cp %{SOURCE9} wagon-providers/wagon-http/build.xml
cp %{SOURCE10} wagon-providers/wagon-http/project.xml
cp %{SOURCE11} wagon-providers/wagon-http-lightweight/build.xml
cp %{SOURCE12} wagon-providers/wagon-http-lightweight/project.xml
cp %{SOURCE13} wagon-providers/wagon-scm/build.xml
cp %{SOURCE14} wagon-providers/wagon-scm/project.xml
cp %{SOURCE15} wagon-providers/wagon-ssh/build.xml
cp %{SOURCE16} wagon-providers/wagon-ssh/project.xml
cp %{SOURCE17} wagon-providers/wagon-ssh-external/build.xml
cp %{SOURCE18} wagon-providers/wagon-ssh-external/project.xml


%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav

%build
%if %{with_maven}
mkdir -p .maven/repository/maven/jars
build-jar-repository .maven/repository/maven/jars \
maven-jelly-tags

mkdir -p .maven/repository/JPP/jars
build-jar-repository -s -p .maven/repository/JPP/jars \
classworlds \
commons-net \
commons-collections \
commons-httpclient \
commons-logging \
concurrent \
excalibur/avalon-framework-api \
excalibur/avalon-framework-impl \
excalibur/cornerstone-connection-api \
excalibur/cornerstone-connection-impl \
excalibur/cornerstone-sockets-api \
excalibur/cornerstone-sockets-impl \
excalibur/cornerstone-threads-api \
excalibur/cornerstone-threads-impl \
excalibur/excalibur-pool-api \
excalibur/excalibur-pool-impl \
excalibur/excalibur-thread-api \
excalibur/excalibur-thread-impl \
jetty4 \
jsch \
oro \
plexus/avalon-personality \
plexus/container-default \
plexus/ftpd \
plexus/interactivity-api \
plexus/jetty-httpd \
plexus/utils \
servletapi4 \
maven-scm/api \
maven-scm/test \
maven-scm/manager-plexus \
maven-scm/provider-cvs \
maven-scm/provider-svn \

export MAVEN_HOME_LOCAL=$(pwd)/.maven

%endif

pushd wagon-provider-api
%if %{with_maven}
maven \
        -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        jar:install javadoc xdoc:transform
%else
mkdir -p target/lib
build-jar-repository -s -p target/lib plexus/utils
ant jar javadoc
%endif
popd

pushd wagon-provider-test
%if %{with_maven}
maven \
        -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        jar:install javadoc
%else
mkdir -p target/lib
cp ../wagon-provider-api/target/wagon-provider-api*.jar target/lib
build-jar-repository -s -p target/lib plexus/container-default plexus/utils junit
ant jar javadoc
%endif
popd

pushd wagon-providers/wagon-file
%if %{with_maven}
maven \
        -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        jar:install javadoc
%else
mkdir -p target/lib
cp ../../wagon-provider-api/target/wagon-provider-api*.jar target/lib
cp ../../wagon-provider-test/target/wagon-provider-test*.jar target/lib
build-jar-repository -s -p target/lib plexus/container-default plexus/utils classworlds
ant jar javadoc
%endif
popd

pushd wagon-providers/wagon-http-lightweight
%if %{with_maven}
maven \
        -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        jar:install javadoc
%else
mkdir -p target/lib
cp ../../wagon-provider-api/target/wagon-provider-api*.jar target/lib
cp ../../wagon-provider-test/target/wagon-provider-test*.jar target/lib
build-jar-repository -s -p target/lib plexus/container-default plexus/jetty-httpd plexus/utils classworlds jetty4 servletapi4
ant jar javadoc
%endif
popd

pushd wagon-providers/wagon-scm
%if %{with_maven}
maven \
        -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        jar:install javadoc
%else
mkdir -p target/lib
cp ../../wagon-provider-api/target/wagon-provider-api*.jar target/lib
cp ../../wagon-provider-test/target/wagon-provider-test*.jar target/lib
build-jar-repository -s -p target/lib plexus/container-default plexus/utils classworlds \
maven-scm/api \
maven-scm/test \
maven-scm/manager-plexus \
maven-scm/provider-cvs \
maven-scm/provider-svn \

ant jar javadoc
%endif
popd

pushd wagon-providers/wagon-ssh-external
%if %{with_maven}
maven \
        -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        -Dtest.host=$(hostname) \
        jar:install javadoc
%else
mkdir -p target/lib
cp ../../wagon-provider-api/target/wagon-provider-api*.jar target/lib
cp ../../wagon-provider-test/target/wagon-provider-test*.jar target/lib
build-jar-repository -s -p target/lib plexus/container-default plexus/utils classworlds
export ANT_OPTS="-Dtest.host=$(hostname)"
ant -Dtest.host=$(hostname) jar javadoc
%endif
popd

pushd wagon-providers/wagon-ssh
%if %{with_maven}
maven \
        -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        -Dmaven.test.skip=true \
        jar:install javadoc xdoc:transform
%else
mkdir -p target/lib
cp ../../wagon-provider-api/target/wagon-provider-api*.jar target/lib
cp ../../wagon-provider-test/target/wagon-provider-test*.jar target/lib
build-jar-repository -s -p target/lib plexus/container-default plexus/utils classworlds \
plexus/interactivity-api plexus/interactivity-jline jsch jline
ant -Dtest.host=$(hostname) jar javadoc
%endif
popd

pushd wagon-providers/wagon-http
%if %{with_maven}
maven \
        -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        -Dmaven.test.failure.ignore=true \
        jar:install javadoc xdoc:transform
%else
mkdir -p target/lib
cp ../../wagon-provider-api/target/wagon-provider-api*.jar target/lib
cp ../../wagon-provider-test/target/wagon-provider-test*.jar target/lib
build-jar-repository -s -p target/lib plexus/container-default plexus/utils classworlds \
commons-httpclient commons-logging plexus/jetty-httpd jetty4 servletapi4
ant jar javadoc
%endif
popd

pushd wagon-providers/wagon-ftp
%if %{with_maven}
maven \
        -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
        -Dmaven.home.local=$MAVEN_HOME_LOCAL \
        -Dmaven.test.skip=true \
        jar:install javadoc xdoc:transform
%else
mkdir -p target/lib
cp ../../wagon-provider-api/target/wagon-provider-api*.jar target/lib
cp ../../wagon-provider-test/target/wagon-provider-test*.jar target/lib
build-jar-repository -s -p target/lib plexus/container-default plexus/utils classworlds \
plexus/avalon-personality plexus/ftpd \
concurrent \
commons-collections commons-net \
excalibur/avalon-framework-api \
excalibur/avalon-framework-impl \
excalibur/cornerstone-connection-api \
excalibur/cornerstone-connection-impl \
excalibur/cornerstone-sockets-api \
excalibur/cornerstone-sockets-impl \
excalibur/cornerstone-threads-api \
excalibur/cornerstone-threads-impl \
excalibur/excalibur-pool-api \
excalibur/excalibur-pool-impl \
excalibur/excalibur-thread-api \
excalibur/excalibur-thread-impl \
oro
ant jar javadoc
%endif
popd

%install
rm -rf $RPM_BUILD_ROOT
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 wagon-provider-api/target/wagon-provider-api-1.0-alpha-5.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/provider-api-%{version}.jar
install -m 644 wagon-providers/wagon-file/target/wagon-file-1.0-alpha-5.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/file-%{version}.jar
install -m 644 wagon-providers/wagon-ftp/target/wagon-ftp-1.0-alpha-5.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/ftp-%{version}.jar
install -m 644 wagon-providers/wagon-http-lightweight/target/wagon-http-lightweight-1.0-alpha-5.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/http-lightweight-%{version}.jar
install -m 644 wagon-providers/wagon-http/target/wagon-http-1.0-alpha-5.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/http-%{version}.jar
install -m 644 wagon-providers/wagon-scm/target/wagon-scm-1.0-alpha-5.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/scm-%{version}.jar
install -m 644 wagon-providers/wagon-ssh-external/target/wagon-ssh-external-1.0-alpha-5.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/ssh-external-%{version}.jar
install -m 644 wagon-providers/wagon-ssh/target/wagon-ssh-1.0-alpha-5.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/ssh-%{version}.jar
install -m 644 wagon-provider-test/target/wagon-provider-test-1.0-alpha-5.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/provider-test-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/provider-api
cp -pr wagon-provider-api/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/provider-api
rm -rf wagon-provider-api/target/docs/apidocs

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/file
cp -pr wagon-providers/wagon-file/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/file
rm -rf wagon-providers/wagon-file/target/docs/apidocs

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/ftp
cp -pr wagon-providers/wagon-ftp/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/ftp
rm -rf wagon-providers/wagon-ftp/target/docs/apidocs

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/http-lightweight
cp -pr wagon-providers/wagon-http-lightweight/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/http-lightweight
rm -rf wagon-providers/wagon-http-lightweight/target/docs/apidocs

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/http
cp -pr wagon-providers/wagon-http/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/http
rm -rf wagon-providers/wagon-http/target/docs/apidocs

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/scm
cp -pr wagon-providers/wagon-scm/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/scm
rm -rf wagon-providers/wagon-scm/target/docs/apidocs

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/ssh-external
cp -pr wagon-providers/wagon-ssh-external/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/ssh-external
rm -rf wagon-providers/wagon-ssh-external/target/docs/apidocs

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/ssh
cp -pr wagon-providers/wagon-ssh/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/ssh
rm -rf wagon-providers/wagon-ssh/target/docs/apidocs

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/provider-test
cp -pr wagon-provider-test/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/provider-test
rm -rf wagon-provider-test/target/docs/apidocs

ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
install -m 644 wagon-provider-api/LICENSE.txt \
		$RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
%if %{with_maven}
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/provider-api
cp -pr wagon-provider-api/target/docs/* \
		$RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/provider-api
#install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/file
#cp -pr wagon-providers/wagon-file/target/docs/* \
#		$RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/file
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/ftp
cp -pr wagon-providers/wagon-ftp/target/docs/* \
		$RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/ftp
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/http
cp -pr wagon-providers/wagon-http/target/docs/* \
		$RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/http
#install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/http-lightweight
#cp -pr wagon-providers/wagon-http-lightweight/target/docs/* \
#		$RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/http-lightweight
#install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/scm
#cp -pr wagon-providers/wagon-scm/target/docs/* \
#		$RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/scm
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/ssh
cp -pr wagon-providers/wagon-ssh/target/docs/* \
		$RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/ssh
#install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/ssh-external
#cp -pr wagon-providers/wagon-ssh-external/target/docs/* \
#		$RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/ssh-external
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(-,root,root,-)
%{_javadir}/*
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%if %{with_maven}
%files manual
%defattr(-,root,root,-)
%doc %{_docdir}/%{name}-%{version}
%endif

%changelog
* Mon Nov 07 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.a5.1jpp
- First JPackage build

